<template>
    <div id="app">
        <AppHeader :scrolled="true" :scrollHandler="false">
            <div class="checkout-tabs">
                <div class="tab past" :class="{past: step >= 1}" data-tab="1">Billing Address</div>
                <div class="tab" :class="{past: step >= 2}" data-tab="2">Payment Method</div>
                <div class="tab" :class="{past: step >= 3}" data-tab="3">Confirmation & Invoice</div>
            </div>
        </AppHeader>
        <main class="checkout">
            <div class="container" id="fix-container">
                <div class="steps">
                    <div class="billing-form">
                        <div class="section-title left">
                            Billing Address
                            <button v-if="step === 2" @click="step = 1">Edit</button>
                        </div>
                        <BillingAddress v-if="step === 1" @set-step="step = $event"></BillingAddress>
                        <div v-if="step === 2">
                            <div class="address-data">
                                <p>{{addressBilling.fullName}}</p>
                                <p>{{addressBilling.address}}, {{addressBilling.city}}, {{addressBilling.state}},
                                    {{addressBilling.zip}}</p>
                                <p>{{addressBilling.country}}</p>
                                <p class="phone" v-if="addressBilling.phone">{{addressBilling.phone}}</p>
                                <p class="email">{{addressBilling.email}}</p>
                            </div>
                        </div>

                        <div class="payment-box" v-if="step === 2">
                            <div class="section-title left">
                                Payment Method
                            </div>
                            <Payment/>
                        </div>
                    </div>
                </div>

                <div class="pkg-info">
                    <affix relative-element-selector="#fix-container" :offset="{ top: 220, bottom: 0 }">
                        <div class="data">
                            <div class="title">Selected Plan</div>
                            <div class="head" v-if="pkgData">
                                <div class="name">{{pkgData.name}}</div>
                                <div class="price" v-if="!pkgData.custom">
                                    <span>${{pkgData.prices[getPlanPrice][0]}},</span>{{pkgData.prices[getPlanPrice][1]}}
                                    <div class="type">{{isSingle ? '/ single payment' : '/ subscription'}}</div>
                                </div>
                                <div class="custom" v-if="pkgData.custom">
                                    Custom Plans
                                </div>
                            </div>
                            <button class="change-plan" @click="changePlan()">Change Plan</button>
                            <button class="switch" @click="onChange">Switch to {{isSingle ? 'Single payment' :
                                'Subscription'}}
                            </button>
                        </div>
                    </affix>
                </div>
            </div>

            <div class="figure12">
                <img srcset="../assets/img/backgrounds/figure12.png, ../assets/img/backgrounds/figure12.2x.png 2x"
                     src="figure12.png" alt="Figure 12">
            </div>
        </main>
        <AppFooter :mt="145"/>
    </div>
</template>

<script>
    import AppHeader from "@/components/AppHeader";
    import Plans from "../data/plans";
    import BillingAddress from "./partials/BillingAddress";
    import Payment from "./partials/Payment";
    import AppFooter from "@/components/AppFooter";
    import {mapGetters} from "vuex";
    import PlansPrices from "./partials/PlansPrices";

    export default {
        name: "Checkout",
        data: () => ({
            pkgData: null,
            step: 1,
        }),
        components: {
            AppHeader,
            AppFooter,
            BillingAddress,
            Payment
        },
        computed: {
            getPlanPrice: function () {
                return this.isSingle ? 'single' : 'subscription';
            },
            ...mapGetters([
                'isSingle',
                'addressBilling'
            ])
        },
        methods: {
            onChange() {
                this.$store.dispatch('setSingle', !this.isSingle)
            },
            changePlan() {
                this.$modal.show(PlansPrices, {inModal: true}, {
                    name: 'plan',
                    scrollable: true,
                    adaptive: true,
                    width: '1060px',
                    height: 'auto'
                })
            }
        },
        mounted: function () {
            const {pkgId} = this.$route.params;
            this.pkgData = Plans('en').planById(pkgId);
        }
    }
</script>

<style scoped lang="scss">


    .checkout-tabs {
        display: flex;
        align-items: center;

        .tab {
            display: flex;
            align-items: center;
            position: relative;
            width: 218px;
            font-family: $mainFont, sans-serif;
            font-size: 18px;
            color: #C8C8CF;
            letter-spacing: .8px;

            & + .tab {
                padding-left: 15px;
            }

            &:before {
                display: block;
                content: attr(data-tab);
                font-family: $secondFont, sans-serif;
                font-size: 11px;
                margin-right: 8px;
            }

            &.past {
                color: #0F0F0F;

                &:after {
                    position: absolute;
                    top: 50%;
                    left: 0;
                    display: block;
                    content: '';
                    width: 100%;
                    height: 1px;
                    background-color: #0F0F0F;
                }

                &:first-child:after {
                    left: 10px;
                    width: calc(100% - 10px);
                }
            }
        }
    }

    .checkout {
        position: relative;
        display: flex;
        justify-content: center;

        .figure12 {
            position: absolute;
            top: -160px;
            left: -300px;
        }

        .container {
            position: relative;
            margin-top: 220px;
            width: 881px;
            display: flex;
            justify-content: space-between;

            .billing-form {
                width: 503px;

                .section-title {
                    margin-top: 40px;

                    button {
                        color: #0263FF;
                        font-family: $mainFont, sans-serif;
                        font-size: 14px;
                        letter-spacing: .86px;
                        background: transparent;
                        border: 0;
                        
                        &:hover {
                            cursor: pointer;
                        }
                    }
                }

                .address-data {
                    margin-top: 43px;

                    p {
                        font-family: $mainFont, sans-serif;
                        font-size: 18px;
                        font-weight: 700;
                        letter-spacing: .8px;
                        color: #4D4D65;
                        line-height: 26px;
                        margin: 0;


                        &.phone {
                            margin-top: 15px;

                            & + .email {
                                margin-top: 0 !important;
                            }
                        }

                        &.email {
                            margin-top: 15px;
                        }
                    }
                }

                .payment-box {
                    margin-top: 120px;
                }
            }

            .pkg-info {
                width: 291px;
                height: 328px;

                .data {
                    width: 291px;
                    height: 328px;
                    background-color: #fff;
                    box-shadow: 0 9px 37px rgba(#BAC3CD, .27);
                    padding-top: 34px;

                    .title {
                        font-family: $secondFont, sans-serif;
                        font-size: 11px;
                        color: #0F0F0F;
                        letter-spacing: 3.9px;
                        text-transform: uppercase;
                        text-align: center;
                    }

                    .head {
                        margin-top: 39px;

                        .name {
                            color: #0f0f0f;
                            font-family: $secondFont, sans-serif;
                            font-size: 34px;
                            font-weight: 700;
                            letter-spacing: 1.6px;
                            text-transform: uppercase;
                            text-align: center;
                        }

                        .price {
                            height: 23px;
                            color: #4D4D65;
                            font-family: $mainFont, sans-serif;
                            font-size: 18px;
                            font-weight: 700;
                            letter-spacing: 0.6px;
                            text-align: center;
                            display: flex;
                            justify-content: center;
                            align-items: center;
                            margin-top: 13px;

                            span {
                                font-size: 20px;
                            }

                            .type {
                                color: #4D4D65;
                                font-size: 18px;
                                margin-left: 8px;
                            }
                        }

                        .custom {
                            height: 23px;
                            color: #4D4D65;
                            font-family: $mainFont, sans-serif;
                            font-size: 20px;
                            font-weight: 700;
                            letter-spacing: 0.6px;
                            text-align: center;
                            margin-top: 10px;
                        }
                    }

                    .change-plan, .switch {
                        display: table;
                        margin: 84px auto 0 auto;
                        border: 0;
                        background: transparent;
                        font-family: $mainFont, sans-serif;
                        font-size: 14px;
                        letter-spacing: .86px;
                        color: #0263FF;

                        &:hover {
                            cursor: pointer;
                        }
                    }

                    .switch {
                        margin: 15px auto 0 auto;
                    }
                }
            }
        }
    }
</style>
